using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;

using Org.Shokai.Util;

namespace Texecize01_03
{
    public partial class Form1 : Form
    {

        private TraceForm traceForm = new TraceForm();
        private SwfConnector swfConnector;
        private String rfidtag_current = "";
        private String swfPath, swfDir;

        public Form1()
        {
            InitializeComponent();
#if DEBUG
            traceForm.Show();
            traceForm.write("---start---");
#endif

            // FlashaxSWFɓǂݍޏ
            traceForm.write("StartupPath: " + Application.StartupPath);
            swfDir = Directory.GetParent(Application.StartupPath).Parent.FullName + @"\swf";
            swfPath = swfDir + @"\BlueletteView.swf"; // ../../swf/foo.swf

            //swfPath = Application.StartupPath + @"\OcxConnectorTest.swf"; // swffBNgȂ
            traceForm.write("swfPath: " + swfPath);

            axSWF.LoadMovie(0, swfPath);
            swfConnector = new SwfConnector(axSWF, "_root.connector");
            swfConnector.onRecvDataFunc += swf_onRecvData;

            // ŏtXN[
            this.FormBorderStyle = FormBorderStyle.None;
            this.WindowState = FormWindowState.Maximized;
            panelControl.Visible = false;
        }

#region swf
        private void swf_onRecvData(AxShockwaveFlashObjects._IShockwaveFlashEvents_FSCommandEvent e)
        {
            switch (e.command)
            {
                case "connector.senddata":
                    traceForm.write("data :" + e.args);
                    switch (e.args)
                    {
                        case "FullScreen": // tXN[
                            this.WindowState = FormWindowState.Normal;
                            this.FormBorderStyle = FormBorderStyle.Sizable;
                            panelControl.Visible = true;
                            break;
                    }
                    break;
                case "connector.debug":
#if DEBUG
                    traceForm.write("debug :" + e.args);
#endif
                    break;
            }
        }
#endregion

#region PhidgetRFID

        public void rfid_init()
        {
            rfid.Outputs[0].State = false; // 5V output
            rfid.Outputs[1].State = false; // external LED
            rfid.Outputs[2].State = true; // on board LED
            rfid.Outputs[3].State = true; // active Reader
        }


        private void rfid_Attach(object sender, EventArgs e)
        {
            rfid_init();
        }

        private void rfid_Detach(object sender, EventArgs e)
        {
            traceForm.write("RFID Detach");
        }

        private void rfid_Error(object sender, GroupLab.Phidgets.PhidgetErrorEventArgs e)
        {
            traceForm.write("RFID Error: " + e.Description);
        }

        private void rfid_OutputChange(object sender, GroupLab.Phidgets.BitStateChangeEventArgs e)
        {
            traceForm.write("RFID OutputChange: " + e.Index + "-" + e.State);
        }

        /// <summary>
        /// RFID^Oǂ񂾎
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void rfid_Tag(object sender, GroupLab.Phidgets.RFIDTagEventArgs e)
        {
            rfidtag_current = e.Tag;
            swfConnector.SendData("tag");
            swfConnector.SendData(rfidtag_current);
            traceForm.write("RFID Tag: " + e.Tag);
        }
#endregion

#region GUI Event
        private void buttonFullscreen_Click(object sender, EventArgs e)
        {
            this.FormBorderStyle = FormBorderStyle.None;
            this.WindowState = FormWindowState.Maximized;
            panelControl.Visible = false;
        }
#endregion

    }
}