/***
  MoveController.as
  WXg̏ɁAMC]ړ
  
  for ActionScript2(Flash8)
  Date: 2006/9/10
  Author: Sho Hashimoto
  WebSite: http://shokai.org
 ***/

import flash.geom.Point;
import RotPoint;

class RotMoveController{

  /*config*/
  var partition:Number = 10; // _Ɠ_̊Ԃ̕
  
  /*member*/
  var points:Array = new Array(); // ړ|Cg̃Xg
  var total:Number = 0; // _̑
  
  /* RXgN^ */
  function MoveController(){
    trace("Create: MoveController");
  }

  /* _ǉ */
  function addPoint(x:Number, y:Number, rotation:Number){
    this.points.push(new RotPoint(x,y, rotation));
    trace("AddMovePoint: "+this.points.length+" ("+x+","+y+","+rotation+")");
    this.total = 1+this.partition*(this.points.length-1);
    return total;
  }

  /* ړ\ */
  function drawPoints(){
    _root.lineStyle (1, 0xFF0000, 100);
    var str:String = "";
    for(var i = 0; i < points.length; i++){
      var p:RotPoint = points[i];
      if(i) _root.lineTo(p.x, p.y);
      else _root.moveTo(p.x, p.y);
      str += " ("+p.x+","+p.y+","+p.rotation+")";
    }
    trace("drawPoints: "+points.length+str);
  }

  /* wʒuMCړ */
  function moveMC(mc:MovieClip, pos:Number){
    if(total <= pos || pos < 0) return false; // ̓_͏o˂
    if(total-1 == pos){ // Ō̓_̎
      var p:RotPoint = points[points.length-1];
      mc._x = p.x;
      mc._y = p.y;
      mc._rotation = p.rotation;
      trace("moveMC: "+pos+"(last) ("+p.x+","+p.y+","+p.rotation+")");
      return p;
    }
    else{
      var line = Math.floor(pos/partition); // ǂ̕ӂ
      var i = pos%partition; // ǂ̕ʒu
      
      var pb:RotPoint = points[line+1];
      var pa:RotPoint = points[line];
      var x = (pb.x-pa.x)/partition*i+pa.x;
      var y = (pb.y-pa.y)/partition*i+pa.y;
      var rotation = (pb.rotation-pa.rotation)/partition*i+pa.rotation;
      var p:RotPoint = new RotPoint(x,y,rotation);
      
      mc._x = x;
      mc._y = y;
      mc._rotation = rotation;
      trace("moveMC: "+pos+" ("+p.x+","+p.y+","+p.rotation+")");
      return p;
    }
  }
  
}
